SystemOrganization addCategory: #'OpenOffice-Importer'!

SAXHandler subclass: #OpenOfficeParser
	instanceVariableNames: 'zipArchive stack ignoreCharacters tagStack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeParser class methodsFor: 'initialize-release' stamp: 'dgd 1/22/2004 17:52'!
unload
	FileList unregisterFileReader: self! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/22/2004 20:24'!
exploreFileNamed: aString 
		(self parseFileNamed: aString) explore! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/22/2004 17:53'!
serviceOpenOpenOfficeDocument
	^ SimpleServiceEntry
		provider: self
		label: 'open the file'
		selector: #openFileNamed:
		description: 'open the open office file'
		buttonLabel: 'open'! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/25/2004 16:03'!
startImage: attributeList 
	| newImage |
	newImage := OpenOfficeImage new.
	""
	attributeList
		at: 'xlink:href'
		ifPresent: [:value | 
			| imageMember | 
			imageMember := zipArchive memberNamed: value allButFirst.
			imageMember isNil
				ifFalse: [| form | 
					form := Form fromBinaryStream: imageMember contentStream.
					newImage form: form]].
	""
	attributeList
		at: 'draw:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newImage style: style].
	""
	attributeList
		at: 'svg:width'
		ifPresent: [:value | newImage width: value].
	attributeList
		at: 'svg:height'
		ifPresent: [:value | newImage height: value].
attributeList
		at: 'svg:x'
		ifPresent: [:value | newImage x: value].
	attributeList
		at: 'svg:y'
		ifPresent: [:value | newImage y: value].
	""
	self top addContents: newImage.
	^ newImage! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/22/2004 20:22'!
serviceOpenOfficeDocumentDOMExplore
	^ SimpleServiceEntry
		provider: self
		label: 'explore the DOM structure'
		selector: #exploreDOMFileNamed:
		description: 'explore the DOM structure.  useful to debug.'
		buttonLabel: 'explore DOM'! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 2/5/2004 14:17'!
startDocument
	super startDocument.
	""
	
	self push: self document! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:14'!
startListItem: attributeList 
	| newList | 
			newList := OpenOfficeListItem new.
			self top addContents: newList.
			^ newList.! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/25/2004 14:34'!
startPage: attributeList 
	| newPage |
	newPage := OpenOfficePage new.
	attributeList
		at: 'draw:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newPage style: style].
	""
	
	attributeList
		at: 'draw:id'
		ifPresent: [:value | newPage id: value].
	attributeList
		at: 'draw:name'
		ifPresent: [:value | newPage name: value].
	""
	self top addContents: newPage.
	^ newPage! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/6/2004 19:31'!
startTextBox: attributeList 
	| newTextBox |
	newTextBox := OpenOfficeTextBox new.
	attributeList
		at: 'draw:text-style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newTextBox style: style].
	attributeList
		at: 'presentation:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newTextBox presentationStyle: style].
	self top addContents: newTextBox.
	^ newTextBox! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 2/5/2004 14:19'!
parseFileNamed: aString 
	"create an instance of the receiver on a file named aString"
	| document |
	document := OpenOfficeDocument new.
	""
	Cursor read
		showWhile: [| file zip contentMember parser | 
			file := FileStream oldFileNamed: aString.
			zip := ZipArchive new readFrom: file.
			""
			self
				parseMemberNamed: 'meta.xml'
				fromZip: zip
				inDocument: document.
			self
				parseMemberNamed: 'styles.xml'
				fromZip: zip
				inDocument: document.
			""
			contentMember := zip memberNamed: 'content.xml'.
			contentMember isNil
				ifTrue: [^ self error: 'missing content.xml'].
			""
			parser := self on: contentMember contentStream ascii.
			parser document: document.
			parser zipArchive: zip.
			parser startDocument.
			parser parseDocument.
			
			""
			file close].
	""
	^ document! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/6/2004 18:03'!
startParagraph: attributeList 
	| newParagraph |
	newParagraph := OpenOfficeParagraph new.""
	attributeList
		at: 'text:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newParagraph style: style].
	attributeList
		at: 'text:level'
		ifPresent: [:value | newParagraph level: value].""
	self top addContents: newParagraph.
	^ newParagraph! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 1/22/2004 18:12'!
endDocument
	self pop.
	super endDocument! !

!OpenOfficeParser methodsFor: 'initialize' stamp: 'dgd 2/6/2004 18:43'!
initialize
	"initialize the receiver's fileName"
	super initialize.
	ignoreCharacters := false.
	""
	stack := OrderedCollection new.
	tagStack := OrderedCollection new.! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/22/2004 20:24'!
serviceOpenOfficeDocumentExplore
	^ SimpleServiceEntry
		provider: self
		label: 'explore the document'
		selector: #exploreFileNamed:
		description: 'explore the document.'
		buttonLabel: 'explore'! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/22/2004 18:13'!
push: anObject 
	"push anObject on the receiver's stack"
	self stack add: anObject! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:11'!
startStyle: attributeList 
| newStyle | 
			newStyle := OpenOfficeStyle fromAttributeList: attributeList.
			self top addStyle: newStyle.
			^ newStyle.! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/25/2004 16:39'!
exploreDOMFileNamed: aString 
	| file zip member dom xmls index |
	file := FileStream oldFileNamed: aString.
	""
	zip := ZipArchive new readFrom: file.
	""
	xmls := zip memberNames
				select: [:each | each endsWith: '.xml'].
	index := (PopUpMenu labelArray: xmls) startUp.
	index isZero
		ifTrue: [""
			self beep.
			^ self].
	""
	member := zip
				memberNamed: (xmls at: index).
	
	dom := XMLDOMParser parseDocumentFrom: member contentStream ascii.
	dom explore.
	""
	file close! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 1/22/2004 18:29'!
startElement: localName namespaceURI: namespaceUri namespace: namespace attributeList: attributeList 
	^ self startElement: localName attributeList: attributeList! !

!OpenOfficeParser methodsFor: 'accessing' stamp: 'dgd 1/25/2004 16:45'!
ignoreCharacters
ignoreCharacters_true! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/22/2004 18:13'!
pop
"pop the last object in the receiver's stack"
	^ self stack removeLast! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/25/2004 12:44'!
fileReaderServicesForFile: fullName suffix: suffix 
	"Answer the file services associated with given file"
	^ (('sx#' match: suffix)
			or: [suffix = '*'])
		ifTrue: [self services]
		ifFalse: [#()]! !

!OpenOfficeParser methodsFor: 'accessing' stamp: 'dgd 1/22/2004 18:10'!
stack
"answer the receiver's stack"
	^ stack! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/6/2004 18:14'!
startTabStop: attributeList 
	self top addContents: '	'.
	^ self top! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:09'!
startLink: attributeList 
	| newLink | 
			newLink := OpenOfficeLink
						on: (attributeList at: 'xlink:href').
			self top addContents: newLink.
^ newLink! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 1/25/2004 16:45'!
characters: aString 
ignoreCharacters ifFalse:[
	self top
		addContents: (self utf8ToSqueak: aString)]! !

!OpenOfficeParser class methodsFor: 'initialize-release' stamp: 'dgd 1/22/2004 17:52'!
initialize
	"initialize the receiver"
	" 
	OpenOfficeParser initialize.
	"
	FileList registerFileReader: self! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:13'!
startOrderedList: attributeList 
	| newList |
	newList := OpenOfficeList type: #ordered.
	self top addContents: newList.
	^ newList! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 2/6/2004 19:35'!
openFileNamed: aString 
	(self parseFileNamed: aString) openAsMorph! !

!OpenOfficeParser methodsFor: 'accessing' stamp: 'dgd 1/24/2004 21:54'!
zipArchive: aZipArchive 
"change the receiver's zipArchive"
	zipArchive := aZipArchive! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/26/2004 11:09'!
parseMemberNamed: aString fromZip: zip inDocument: aDocument 
	| member parser |
	member := zip memberNamed: aString.
	member isNil
		ifTrue: [^ self].
	""
	parser := self on: member contentStream ascii.
	parser ignoreCharacters.
	parser zipArchive: zip.
	parser document: aDocument.
	parser startDocument.
	parser parseDocument! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/22/2004 17:55'!
utf8ToSqueak: aString 
	" 
	self new utf8ToSqueak: 'Diego Gómez Deck'
	"
	| result input |
	result := String new writeStream.
	""
	input := aString readStream.
	input
		do: [:each | 
			| value1 | 
			value1 := each asciiValue.
			value1 < 128
				ifTrue: [result nextPut: each]
				ifFalse: [| value2 char | 
					"2-byte character"
					char := $..
					(value1 bitAnd: 224)
							= 192
						ifTrue: [""
							value2 := input next asciiValue.
							char := (Character value: ((value1 bitAnd: 31)
											bitShift: 6)
											+ (value2 bitAnd: 63)) isoToSqueak].
					""
					(value1 bitAnd: 240)
							= 224
						ifTrue: ["3-byte character"
							input next asciiValue.
							input next asciiValue.
							char := $.].
					""
					(value1 bitAnd: 248)
							= 240
						ifTrue: ["4-byte character"
							input next asciiValue.
							input next asciiValue.
							input next asciiValue.
							char := $.].
					""
					result nextPut: char]].
	""
	^ result contents! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 2/6/2004 18:44'!
startElement: elementName attributeList: attributeList 
	| selectors |
tagStack add: elementName.
""
	selectors := Dictionary new.
	selectors at: 'text:p' put: #startParagraph:.
	selectors at: 'text:h' put: #startHeader:.
	selectors at: 'text:span' put: #startSpan:.
	selectors at: 'text:section' put: #startSection:.
	selectors at: 'text:a' put: #startLink:.
	selectors at: 'dc:title' put: #startTitle:.
	selectors at: 'style:style' put: #startStyle:.
	selectors at: 'style:properties' put: #startProperties:.
	selectors at: 'text:unordered-list' put: #startUnorderedList:.
	selectors at: 'text:ordered-list' put: #startOrderedList:.
	selectors at: 'text:list-item' put: #startListItem:.
	selectors at: 'draw:image' put: #startImage:.
	selectors at: 'draw:page' put: #startPage:.
	selectors at: 'draw:text-box' put: #startTextBox:.
	selectors at: 'office:document-content' put: #startDocumentContent:.
	""
	selectors at: 'table:table' put: #startTable:.
	selectors at: 'table:table-row' put: #startTableRow:.
	selectors at: 'table:table-cell' put: #startTableCell:.
	""
	selectors
		at: elementName
		ifPresent: [:selector | 
			self
				push: (self perform: selector with: attributeList).
			^ self].
	" 
	unknown := OpenOfficeUnknown tag: elementName. 
	self top addContents: unknown. 
	self push: unknown 
	"
	self push: self top! !

!OpenOfficeParser class methodsFor: 'filelist-services' stamp: 'dgd 1/25/2004 12:44'!
services
	"Answer potential file services associated with this class"
	^ {self serviceOpenOpenOfficeDocument. self serviceOpenOfficeDocumentExplore. self serviceOpenOfficeDocumentDOMExplore}! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:13'!
startUnorderedList: attributeList 
	| newList | 
			newList := OpenOfficeList type: #unordered.
			self top addContents: newList.
			^newList.! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/5/2004 14:54'!
startTable: attributeList 
	| newTable |
	newTable := OpenOfficeTable new.
	attributeList
		at: 'table:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newTable style: style].
	self top addContents: newTable.
	^ newTable! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 1/22/2004 18:30'!
endElement: localName namespace: namespace namespaceURI: uri qualifiedName: qualifiedName 
	self endElement: localName! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/25/2004 13:24'!
startDocumentContent: attributeList 
	attributeList
		at: 'office:class'
		ifPresent: [:value | self top type: value].
	^ self top! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/25/2004 11:35'!
startSection: attributeList 
	| newSection |
	newSection := OpenOfficeSection new.
	attributeList
		at: 'text:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newSection style: style].
	self top addContents: newSection.
	^ newSection! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/5/2004 14:58'!
startTableCell: attributeList 
	| newTableCell |
	newTableCell := OpenOfficeTableCell new.
	attributeList
		at: 'table:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newTableCell style: style].
	self top addContents: newTableCell.
	^ newTableCell! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/5/2004 14:58'!
startTableRow: attributeList 
	| newTableRow |
	newTableRow := OpenOfficeTableRow new.
	attributeList
		at: 'table:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newTableRow style: style].
	self top addContents: newTableRow.
	^ newTableRow! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 2/6/2004 18:02'!
startHeader: attributeList 
	| newHeader |
	newHeader := self startParagraph: attributeList .
	newHeader beHeader.
	
	^ newHeader! !

!OpenOfficeParser methodsFor: 'content' stamp: 'dgd 2/6/2004 18:45'!
endElement: elementName 
	self pop.
	tagStack removeLast! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/22/2004 18:14'!
top
	"answer the top most object on the stack"
	^ self stack isEmpty
		ifFalse: [self stack last]! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/24/2004 22:10'!
startTitle: attributeList 
| newTitle | 
			newTitle := OpenOfficeDocumentTitle new.
			self top title: newTitle.
^ newTitle! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/26/2004 11:14'!
startProperties: attributeList 
	"(self top respondsTo: #processProperties:)
		ifTrue: [self top processProperties: attributeList].
	" 
	self top processProperties: attributeList.
""
	^ self top! !

!OpenOfficeParser methodsFor: 'private' stamp: 'dgd 1/25/2004 11:35'!
startSpan: attributeList 
	| newSpan |
	newSpan := OpenOfficeSpan new.
	attributeList
		at: 'text:style-name'
		ifPresent: [:value | 
			| style | 
			style := self top styleNamed: value.
			newSpan style: style].
	self top addContents: newSpan.
	^ newSpan! !

StringHolder subclass: #OpenOfficeStringHolder
	instanceVariableNames: 'document '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeStringHolder methodsFor: 'user interface' stamp: 'dgd 1/26/2004 11:35'!
initialExtent
	"Answer the desired extent for the receiver when a view on it is 
	first opened on the screen."
^ document pageExtent ifNil:[ super initialExtent]! !

!OpenOfficeStringHolder methodsFor: 'evaluation' stamp: 'dgd 1/26/2004 11:57'!
doItReceiver
	"Answer the object that should be informed of the result of 
	evaluating a text selection."
	^ document ifNil:[super doItReceiver]! !

!OpenOfficeStringHolder methodsFor: 'initialization' stamp: 'dgd 1/26/2004 11:31'!
initializeDocument: aDocument 
	"initialize the recevier's document"
	document := aDocument! !

!OpenOfficeStringHolder methodsFor: 'user interface' stamp: 'dgd 1/26/2004 11:50'!
defaultBackgroundColor
	"Answer the color to be used as the base window color for a  
	window whose model is an object of the receiver's class"
	^ Color paleYellow! !

!OpenOfficeStringHolder methodsFor: 'opening' stamp: 'dgd 1/26/2004 11:32'!
open
"open the receiver's with document"
	self contents: document asText.
	self openLabel: document title string! !

!OpenOfficeStringHolder class methodsFor: 'instance creation' stamp: 'dgd 1/26/2004 11:30'!
document: aDocument 
"answer an instence of the receiver on aDocument"
	^ self new initializeDocument: aDocument! !

Object subclass: #OpenOfficeStyle
	instanceVariableNames: 'name parent family parentName listStyleName masterPageName dataStyleName properties styleClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:24'!
color
	"answer the receiver's color"
	^ self propertyNamed: 'fo:color'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:39'!
properties
	^properties! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:26'!
autoGrowWidth
	"answer the receiver's autoGrowWidth"
	^ (self propertyNamed: 'draw:auto-grow-width') = 'true'! !

!OpenOfficeStyle methodsFor: 'printing' stamp: 'dgd 2/5/2004 14:52'!
printOn: aStream 
	"append to aStream a sequence of characters that identifies  
	the receiver."
	super printOn: aStream.
	aStream nextPutAll: ' name:';
		 nextPutAll: self name asString
;
nextPutAll: ', family:';
		 nextPutAll: self family asString
! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:18'!
horizontalPos
	"answer the receiver's horizontalPos"
	^ self propertyNamed:  'style:horizontal-pos'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:16'!
textUnderline
	"answer the receiver's textUnderline"
	^ self propertyNamed:  'style:text-underline'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:15'!
textAlign
	"answer the receiver's textAlign"
	
	^ self propertyNamed: 'fo:text-align'! !

!OpenOfficeStyle methodsFor: 'initialization' stamp: 'dgd 2/6/2004 20:28'!
initialize
	"initialize the receiver"
	properties := Dictionary new! !

!OpenOfficeStyle class methodsFor: 'instance creation' stamp: 'dgd 2/6/2004 20:28'!
new
	"answer an instance of the receiver"
	^ super new initialize! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:19'!
fontWeight
	"answer the receiver's fontWeight"
	^ self propertyNamed:'fo:font-weight'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:22'!
fontName
	"answer the receiver's fontName"
	^  self propertyNamed:    'style:font-name'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/5/2004 14:24'!
parentStyle
	"answer the parent style of the receiver"
	parentName isNil
		ifTrue: [^ nil].
	parent isNil
		ifTrue: [^ nil].
^ parent styleNamed: parentName ! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:20'!
fontSize
	"answer the receiver's fontSize"
	^  self propertyNamed: 'fo:font-size'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:26'!
minHeight
	"answer the receiver's minHeight"
	^ (self propertyNamed:'fo:min-height')
		! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/5/2004 14:22'!
parent: anElement 
	"chante the receiver's parent"
	parent := anElement! !

!OpenOfficeStyle methodsFor: 'private' stamp: 'dgd 2/5/2004 14:28'!
fontAttribute
	"private - answer the font attributes"
	| textStyle size |
	textStyle := self fontName isNil
				ifTrue: [TextStyle default]
				ifFalse: [(TextStyle named:  self fontName asSymbol)
						ifNil: [TextStyle default]].
	""
	size := self  fontSize isNil
				ifTrue: [15]
				ifFalse: [ self fontSize asInteger * 1.3].
	""
	^ TextFontChange
		fontNumber: (textStyle copy fontIndexOfSize: size)! !

!OpenOfficeStyle methodsFor: 'converting' stamp: 'dgd 2/5/2004 17:19'!
asAttributes
	"answer the attributes representing the receiver"
	| attributes |
	attributes := OrderedCollection new.
	""
	self color isNil
		ifFalse: [attributes add: self colorAttribute].
	self textAlign isNil
		ifFalse: [attributes add: self alignAttribute].
	""
	self fontStyle = 'italic'
		ifTrue: [attributes add: TextEmphasis italic].
	self fontWeight = 'bold'
		ifTrue: [attributes add: TextEmphasis bold].
	self textUnderline = 'single'
		ifTrue: [attributes add: TextEmphasis underlined].
	""
	self fontSize notNil | self fontName notNil
		ifTrue: [attributes add: self fontAttribute].
	""
	^ attributes! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:23'!
fillColor
	"answer the receiver's fillColor"
	^ self propertyNamed:  'draw:fill-color'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:20'!
fontStyle
	"answer the receiver's fontStyle"
	^  self propertyNamed:'fo:font-style'! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 1/22/2004 20:31'!
name"answer the receiver's name"
	^ name! !

!OpenOfficeStyle class methodsFor: 'instance creation' stamp: 'dgd 1/22/2004 20:29'!
fromAttributeList: attributeList 
	"answer a new instance of the receiver with information from attributeList"
	^ self new initializeAttributeList: attributeList ! !

!OpenOfficeStyle methodsFor: 'initialization' stamp: 'dgd 2/8/2004 14:42'!
initializeAttributeList: attributeList 
	"initialize the receiver from attributeList"
	| |
	name := attributeList at: 'style:name'.
	""
	attributeList
		at: 'style:family'
		ifPresent: [:value | family := value].
	attributeList
		at: 'style:parent-style-name'
		ifPresent: [:value | parentName := value].
	attributeList
		at: 'style:master-page-name'
		ifPresent: [:value | masterPageName := value].
	attributeList
		at: 'style:list-style-name'
		ifPresent: [:value | listStyleName := value].
	attributeList
		at: 'style:data-style-name'
		ifPresent: [:value | dataStyleName := value].
	attributeList
		at: 'style:class'
		ifPresent: [:value | styleClass := value].
	! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/5/2004 14:53'!
family
	"answer the receiver's family"
	^ family! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:25'!
backgroundColor
	"answer the receiver's backgroundColor"
	^ self propertyNamed:  'fo:background-color'! !

!OpenOfficeStyle methodsFor: 'private' stamp: 'dgd 2/5/2004 14:27'!
alignAttribute
	"private - answer the align attributes"
	(self textAlign = 'justify'
			or: [self horizontalPos = 'justify'])
		ifTrue: [^ TextAlignment justified].
	(self textAlign = 'center'
			or: [self horizontalPos = 'center'])
		ifTrue: [^ TextAlignment centered].
	(self textAlign = 'end'
			or: [self horizontalPos = 'end'])
		ifTrue: [^ TextAlignment rightFlush].
	""
	^ TextAlignment leftFlush! !

!OpenOfficeStyle methodsFor: 'initialization' stamp: 'dgd 2/6/2004 20:29'!
processProperties: attributeList 
	"process an attributeList of properties"
	
	attributeList
		keysAndValuesDo: [:key :value | properties at: key put: value]! !

!OpenOfficeStyle methodsFor: 'accessing' stamp: 'dgd 2/6/2004 20:29'!
propertyNamed: aString 
	"answer the receiver's property with a given name. if none,  
	looks in parent style"
	| parentStyle |
	
			properties
				at: aString
				ifPresent: [:value | ^ value].
	""
	parentStyle := self parentStyle.
	parentStyle isNil
		ifTrue: [^ nil].
	""
	^ parentStyle propertyNamed: aString! !

!OpenOfficeStyle methodsFor: 'private' stamp: 'dgd 2/5/2004 14:26'!
colorAttribute
	"private - answer the color attributes"
	^ TextColor
		color: (Color fromString: self color)! !

Object subclass: #OpenOfficeElement
	instanceVariableNames: 'parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeElement class methodsFor: 'instance creation' stamp: 'dgd 1/22/2004 20:11'!
new
	"answer a new instance of the receiver"
	^ super new initialize! !

!OpenOfficeElement methodsFor: 'accessing' stamp: 'dgd 1/24/2004 20:51'!
parent
"answer the receiver's parent"
^parent! !

!OpenOfficeElement methodsFor: 'converting' stamp: 'dgd 1/22/2004 19:13'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	self subclassResponsibility! !

!OpenOfficeElement methodsFor: 'private' stamp: 'dgd 1/25/2004 16:08'!
pixelsFromString: aString 
	"private - answer aString converted to pixels"
	| number |
	aString isNil
		ifTrue: [^ nil].
	""
number _ aString asNumber.
	(aString endsWith: 'pt')
		ifTrue: [^ (number * 1.25) rounded].
	(aString endsWith: 'pc')
		ifTrue: [^ (number * 15) rounded].
	(aString endsWith: 'mm')
		ifTrue: [^ (number * 3.543307) rounded].
	(aString endsWith: 'cm')
		ifTrue: [^ (number * 35.43307) rounded].
	((aString endsWith: 'in')
			or: [aString endsWith: 'inch'])
		ifTrue: [^ (number * 90) rounded].
	""
	^ number rounded! !

!OpenOfficeElement methodsFor: 'accessing' stamp: 'dgd 1/24/2004 20:52'!
parent: anElement
	"chante the receiver's parent"
	parent_anElement! !

OpenOfficeElement subclass: #OpenOfficeDocumentTitle
	instanceVariableNames: 'string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeDocumentTitle methodsFor: 'accessing' stamp: 'dgd 1/24/2004 21:01'!
addContents: aString "add aString to the receiver's contents"
	string := string , aString! !

!OpenOfficeDocumentTitle methodsFor: 'initialization' stamp: 'dgd 1/22/2004 20:12'!
initialize"initialize the receiver"
	super initialize.
	""
	string := ''! !

!OpenOfficeDocumentTitle methodsFor: 'accessing' stamp: 'dgd 1/25/2004 13:30'!
string
	"answer the receiver's string"
	^ string isEmpty
		ifTrue: ['Untitled' translated]
		ifFalse: [string]! !

!OpenOfficeElement methodsFor: 'accessing' stamp: 'dgd 1/24/2004 21:50'!
hasParent
	"answer whatever the receiver has parent"
	^ self parent notNil! !

!OpenOfficeElement methodsFor: 'initialization' stamp: 'dgd 1/22/2004 20:12'!
initialize
	"initialize the receiver"! !

!OpenOfficeElement methodsFor: 'converting' stamp: 'dgd 1/22/2004 19:14'!
asText
	"answer a Text version of the receiver"
	^ Text
		streamContents: [:stream | self asTextIn: stream]! !

!OpenOfficeElement methodsFor: 'accessing' stamp: 'dgd 1/24/2004 21:50'!
topParent
	"answer the topmost parent"
	^ self hasParent ifFalse:[self] ifTrue:[self parent topParent]! !

!OpenOfficeElement methodsFor: 'testing' stamp: 'dgd 2/6/2004 19:40'!
isPage
"answer whatever the receiver is a page"
	^ false! !

OpenOfficeElement subclass: #OpenOfficeImage
	instanceVariableNames: 'form style x y width height '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeImage methodsFor: 'converting' stamp: 'dgd 1/25/2004 15:50'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	| morph |
	form isNil
		ifTrue: [^ self].
	""
	morph := SketchMorph withForm: form.
	width isNil
		ifFalse: [morph width:(self pixelsFromString: width)].
	height isNil
		ifFalse: [morph
				height: (self pixelsFromString: height)].
	""
	aTextStream
		withAttribute: (TextAnchor new anchoredMorph: morph)
		do: [aTextStream
				nextPut: (Character value: 1)].
	""
	style isNil
		ifFalse: [aTextStream applyAttribute: style alignAttribute beginningAt: aTextStream position - 1]! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/24/2004 23:00'!
style: aStyle 
"change the receiver's style"
	style := aStyle! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 16:04'!
y: aString 
	"change the receiver's y"
	y := aString! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 16:04'!
x: aString 
	"change the receiver's x"
	x := aString! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 15:27'!
height: aString 
	"change the receiver's height"
	height := aString! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 15:27'!
width: aString 
"change the receiver's width"
	width := aString! !

!OpenOfficeImage methodsFor: 'accessing' stamp: 'dgd 1/24/2004 21:55'!
form: aForm 
	"change the receiver's form"
	form := aForm! !

OpenOfficeElement subclass: #OpenOfficeContentsHolder
	instanceVariableNames: 'contents styles '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

OpenOfficeContentsHolder subclass: #OpenOfficeList
	instanceVariableNames: 'type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeList methodsFor: 'bullets' stamp: 'dgd 1/25/2004 15:36'!
bulletForItem: aListItem 
	"answer the bullet corresponding to aListItem"
	| number |
	type == #ordered
		ifFalse: [^ '	'].
	""
	number := self contents
				indexOf: aListItem
				ifAbsent: [0].
	^ number asString , '-	'! !

!OpenOfficeList methodsFor: 'initialization' stamp: 'dgd 1/24/2004 20:43'!
initialize
	"initialize the receiver"
	super initialize.
	""
	type := #unordered! !

!OpenOfficeList methodsFor: 'initialization' stamp: 'dgd 1/24/2004 20:44'!
initializeType: aSymbol 
	"initialize the receiver's type (#ordered or #unordered)"
	type := aSymbol! !

!OpenOfficeList class methodsFor: 'instance creation' stamp: 'dgd 1/24/2004 20:43'!
type: aSymbol
	"answer a new instance of the receiver of a given type"
^self new initializeType: aSymbol! !

!OpenOfficeList methodsFor: 'printing' stamp: 'dgd 1/25/2004 13:27'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters  
	that identifies the receiver."
	super printOn: aStream.
	""
	aStream nextPutAll: ' type:';
		 nextPutAll: self type asString! !

!OpenOfficeList methodsFor: 'accessing' stamp: 'dgd 1/25/2004 13:28'!
type
	"answer the receiver's type"
	^ type! !

OpenOfficeContentsHolder subclass: #OpenOfficeDocument
	instanceVariableNames: 'title type pageWidth pageHeight marginRight marginLeft marginBottom marginTop '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/22/2004 20:13'!
title: aDocumentTitle 
"change the receiver's title"
	title := aDocumentTitle! !

!OpenOfficeDocument methodsFor: 'initialization' stamp: 'dgd 1/26/2004 11:21'!
processProperties: attributeList 
	"process an attributeList of properties"
	attributeList
		at: 'fo:page-width'
		ifPresent: [:value | self pageWidth: value].
	attributeList
		at: 'fo:page-height'
		ifPresent: [:value | self pageHeight: value].
	""
	attributeList
		at: 'fo:margin-right'
		ifPresent: [:value | self marginRight: value].
	attributeList
		at: 'fo:margin-left'
		ifPresent: [:value | self marginLeft: value].
	attributeList
		at: 'fo:margin-bottom'
		ifPresent: [:value | self marginBottom: value].
	attributeList
		at: 'fo:margin-top'
		ifPresent: [:value | self marginTop: value].
	""
	'style:writing-mode'.
	'style:layout-grid-ruby-below'.
	'style:layout-grid-print'.
	'style:layout-grid-display'.
	'style:layout-grid-mode'.
	'style:layout-grid-ruby-height'.
	'style:layout-grid-color'.
	'style:layout-grid-lines'.
	'style:print-orientation'.
	'style:footnote-max-height'.
	'style:layout-grid-base-height'.
	'style:num-format'.
	'pageWidth pageHeight marginRight marginLeft marginBottom marginTop'! !

!OpenOfficeDocument methodsFor: 'displaying' stamp: 'dgd 2/6/2004 19:39'!
pages
^ self contents select:[:each | each isPage]! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:22'!
marginBottom: aString 
"change the receiver's marginBottom"
	marginBottom := aString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/25/2004 13:24'!
type: aString 
	"change the receiver's type"
	type := aString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:22'!
marginTop: aString 
	"change the receiver's marginTop"
	marginTop := aString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/22/2004 19:24'!
title
	"answer the receiver's title"
	^ title! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:23'!
pageHeight: aString 
	"change the receiver's pageHeight"
	pageHeight := aString! !

!OpenOfficeDocument methodsFor: 'displaying' stamp: 'dgd 2/6/2004 19:39'!
openAsMorph
	"open a morph with the receiver's content"
	type = 'presentation'
		ifTrue: [self openBookMorph]
		ifFalse: [(OpenOfficeStringHolder document: self) open]! !

!OpenOfficeDocument methodsFor: 'printing' stamp: 'dgd 1/25/2004 13:30'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters  
	that identifies the receiver."
	super printOn: aStream.
	""
	aStream nextPutAll: ' title:';
		 nextPutAll: self title string;
		 nextPutAll: ', type:';
		 nextPutAll: self type asString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:23'!
pageWidth: aString 
"change the receiver's pageWidth"
	pageWidth := aString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:22'!
marginRight: aString 
	"change the receiver's marginRight"
	marginRight := aString! !

!OpenOfficeDocument class methodsFor: 'instance creation' stamp: 'dgd 1/22/2004 18:10'!
new
	"answer a new instance of the receiver"
^ super new initialize! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/25/2004 15:26'!
type
"answer the receiver's type"
	^ type! !

!OpenOfficeDocument methodsFor: 'initialization' stamp: 'dgd 1/25/2004 13:16'!
initialize
	"initialize the receiver"
	super initialize.
	""
	title := OpenOfficeDocumentTitle new.
	! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:22'!
marginLeft: aString 
"change the receiver's marginLeft"
	marginLeft := aString! !

!OpenOfficeDocument methodsFor: 'accessing' stamp: 'dgd 1/26/2004 11:45'!
pageExtent
	"answer the desired page extent considering the page size and the margins"
	| w h extent ml mr mt mb |
	w := self pixelsFromString: pageWidth.
	h := self pixelsFromString: pageHeight.
	w isNil | h isNil
		ifTrue: [^ nil].
	""
	extent := w @ h.
	""
	ml := (self pixelsFromString: marginLeft)
				ifNil: [0].
	mr := (self pixelsFromString: marginRight)
				ifNil: [0].
	mt := (self pixelsFromString: marginTop)
				ifNil: [0].
	mb := (self pixelsFromString: marginBottom)
				ifNil: [0].
	""
	extent := extent - (ml @ mt) - (mr @ mb).
	""
	^ extent! !

!OpenOfficeDocument methodsFor: 'displaying' stamp: 'dgd 2/6/2004 19:54'!
openBookMorph
	| book pages |
	book := BookMorph new.
	book borderColor: Color black;
		 borderWidth: 1;
		 pageSize: 640 @ 480.
	""
	pages := self pages
				collect: [:each | each asMorph].
	book pages: pages.
	book firstPage.
	""
	book openInWorld! !

OpenOfficeContentsHolder subclass: #OpenOfficeLink
	instanceVariableNames: 'link '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeLink methodsFor: 'accessing' stamp: 'dgd 1/25/2004 13:27'!
link
"answer the receiver's link"
	^ link! !

!OpenOfficeLink methodsFor: 'printing' stamp: 'dgd 1/25/2004 13:26'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters  
	that identifies the receiver."
	super printOn: aStream.
	""
	aStream nextPutAll: ' link:';
		 nextPutAll: self link asString.
	! !

!OpenOfficeLink class methodsFor: 'instance creation' stamp: 'dgd 1/22/2004 18:34'!
on: linkString
	"answer a new instance of the receiver on linkString"
	^ self new initializeLink: linkString! !

!OpenOfficeLink methodsFor: 'initialization' stamp: 'dgd 1/22/2004 18:34'!
initializeLink: linkString "initialize the receiver's link"
	link := linkString! !

!OpenOfficeLink methodsFor: 'converting' stamp: 'dgd 1/22/2004 19:25'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	link isNil
		ifTrue: [super asTextIn: aTextStream]
		ifFalse: [| url | 
			url := (TextURL new analyze: link;
						 yourself).
			aTextStream
				withAttribute: url
				do: [super asTextIn: aTextStream]]! !

OpenOfficeContentsHolder subclass: #OpenOfficeUnknown
	instanceVariableNames: 'tag '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeUnknown methodsFor: 'as yet unclassified' stamp: 'dgd 2/6/2004 18:38'!
processProperties: attributeList 
! !

!OpenOfficeUnknown methodsFor: 'initialization' stamp: 'dgd 1/25/2004 11:18'!
initializeTag: aString "initialize the receiver's tag"
	tag := aString! !

!OpenOfficeUnknown methodsFor: 'printing' stamp: 'dgd 1/25/2004 11:18'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters 
	that identifies the receiver."
super printOn: aStream .
""
aStream nextPutAll:' tag:';nextPutAll: tag asString! !

!OpenOfficeUnknown class methodsFor: 'instance creation' stamp: 'dgd 1/25/2004 11:17'!
tag: aString
"answer an instance of the receiver with as given tag"
	^ self new initializeTag: aString! !

!OpenOfficeContentsHolder methodsFor: 'accessing' stamp: 'dgd 1/24/2004 20:52'!
addContents: anObject 
	"add anObject to the receiver's contents"
anObject isString ifFalse:[
	anObject parent: self].
	^ contents add: anObject! !

!OpenOfficeContentsHolder methodsFor: 'accessing' stamp: 'dgd 2/5/2004 14:22'!
addStyle: aStyle 
	"add aStyle to the receiver's styles collection"
	aStyle parent: self.
	^ styles add: aStyle! !

!OpenOfficeContentsHolder methodsFor: 'accessing' stamp: 'dgd 1/22/2004 19:15'!
contents
	"answer the receiver's contents"
	^ contents! !

!OpenOfficeContentsHolder methodsFor: 'converting' stamp: 'dgd 1/22/2004 19:13'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	self contents
		do: [:each | each asTextIn: aTextStream]! !

OpenOfficeContentsHolder subclass: #OpenOfficeStyledContentsHolder
	instanceVariableNames: 'style '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeStyledContentsHolder methodsFor: 'accessing' stamp: 'dgd 1/25/2004 14:30'!
style: aStyle 
	"change the receiver's style"
	style := aStyle! !

!OpenOfficeStyledContentsHolder methodsFor: 'converting' stamp: 'dgd 1/25/2004 14:31'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	style isNil
		ifTrue: [super asTextIn: aTextStream]
		ifFalse: [""
			aTextStream
				withAttributes: style asAttributes
				do: [super asTextIn: aTextStream]]! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeParagraph
	instanceVariableNames: 'isHeader level '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeParagraph methodsFor: 'accessing' stamp: 'dgd 2/6/2004 18:01'!
level: anObject
	level _ anObject! !

!OpenOfficeParagraph methodsFor: 'initialization' stamp: 'dgd 2/6/2004 17:58'!
initialize"initialize the receiver"
	super initialize.
	""
	isHeader := false! !

!OpenOfficeParagraph methodsFor: 'converting' stamp: 'dgd 1/25/2004 13:11'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	super asTextIn: aTextStream.
	
	aTextStream cr! !

!OpenOfficeParagraph methodsFor: 'accessing' stamp: 'dgd 2/6/2004 17:59'!
beHeader
	"change the receiver to be a header"
	isHeader _ true.! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeTable methodsFor: 'converting' stamp: 'dgd 2/5/2004 19:23'!
asMorph
	| morph |
	morph := AlignmentMorph newColumn.
	morph color: Color transparent;
		 borderWidth: 1;
		 layoutInset: 0; hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	""
	self contents
		do: [:each | morph addMorphBack: each asMorph].
	""
	^ morph! !

!OpenOfficeTable methodsFor: 'converting' stamp: 'dgd 2/5/2004 19:12'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	
	aTextStream cr.
	""
	aTextStream
		withAttribute: (TextAnchor new anchoredMorph: self asMorph)
		do: [aTextStream
				nextPut: (Character value: 1)].
	aTextStream cr! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficePage
	instanceVariableNames: 'id name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficePage methodsFor: 'converting' stamp: 'dgd 2/6/2004 20:00'!
asMorph
	| childrenTextStream textMorph morph |
	childrenTextStream := TextStream
				on: (Text new: 400).
	super asTextIn: childrenTextStream.
	""
	textMorph := TextMorph new.
	textMorph contents: childrenTextStream contents allButLast.
	""
	morph := PasteUpMorph new.
	morph setNameTo: self name asString;
		 color: Color white;
		 borderColor: Color black;
		 borderWidth: 0;
		 layoutInset: 2;
		 extent: 640 @ 480.
	""
	morph addMorphBack: textMorph.
	""
	^ morph! !

!OpenOfficePage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 12:50'!
id: aString
"change the receiver's id"
	id := aString! !

!OpenOfficePage methodsFor: 'printing' stamp: 'dgd 1/25/2004 13:28'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters  
	that identifies the receiver."
	super printOn: aStream.
	""
	aStream nextPutAll: ' id:';
		 nextPutAll: self id asString;
nextPutAll: ', name:';
		 nextPutAll: self name asString.! !

!OpenOfficePage methodsFor: 'converting' stamp: 'dgd 1/25/2004 13:10'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	| line |
	super asTextIn: aTextStream.
	""
	aTextStream cr.
	line := LineMorph
				from: 0 @ 0
				to: 800 @ 0
				color: Color lightGray
				width: 1.
	aTextStream
		withAttribute: (TextAnchor new anchoredMorph: line)
		do: [aTextStream
				nextPut: (Character value: 1)].
	aTextStream cr.! !

!OpenOfficePage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 12:51'!
name
	"answer the receiver's name"
	^name ! !

!OpenOfficePage methodsFor: 'testing' stamp: 'dgd 2/6/2004 19:40'!
isPage
	"answer whatever the receiver is a page"
	^ true! !

!OpenOfficePage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 13:29'!
id
"answer the receiver's id"
	^ id! !

!OpenOfficePage methodsFor: 'accessing' stamp: 'dgd 1/25/2004 12:50'!
name: aString 
"change the receiver's name"
	name := aString! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeTableRow methodsFor: 'converting' stamp: 'dgd 2/5/2004 19:23'!
asMorph
	| morph |
	morph := AlignmentMorph newRow.
	morph color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 0; hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 extent: 5 @ 5.
	""
	self contents
		do: [:each | morph addMorphBack: each asMorph].
	""
	^ morph! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeTextBox
	instanceVariableNames: 'presentationStyle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeTextBox methodsFor: 'converting' stamp: 'dgd 1/25/2004 14:49'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	| childrenTextStream textMorph |
	childrenTextStream := TextStream
				on: (Text new: 400).
	super asTextIn: childrenTextStream.
	""
	aTextStream cr.
	textMorph := self createTextMorph:  childrenTextStream contents.

	""
	aTextStream
		withAttribute: (TextAnchor new anchoredMorph: textMorph)
		do: [aTextStream
				nextPut: (Character value: 1)].
	aTextStream cr! !

!OpenOfficeTextBox methodsFor: 'converting' stamp: 'dgd 1/25/2004 15:29'!
createTextMorph: aText 
"private - create a TextMorph representing the receiver"
	| textMorph color |
	textMorph := TextMorph new.
	""
	textMorph autoFit: self autoGrowWidth;
		 contents: aText;
		 wrapFlag: true;
		 paragraph.
	"borderWidth: 1;"
	""
	color := self fillColor.
	color isNil
		ifFalse: [textMorph backgroundColor: color].
	""
	self flag: #todo.
	"fix this awful hack"
	textMorph width > 574
		ifTrue: [textMorph width: 574].
	""
	^ textMorph! !

!OpenOfficeTextBox methodsFor: 'accessing' stamp: 'dgd 1/25/2004 15:10'!
presentationStyle: aStyle 
"change the receiver's presentationStyle"
	presentationStyle := aStyle! !

!OpenOfficeTextBox methodsFor: 'private' stamp: 'dgd 1/25/2004 15:29'!
autoGrowWidth
	"private - answer the autoGrowWidth from the  
	presentationStyle (if any)"
	presentationStyle isNil
		ifTrue: [^ false].
	""
	^ presentationStyle autoGrowWidth == true! !

!OpenOfficeTextBox methodsFor: 'private' stamp: 'dgd 1/25/2004 15:28'!
fillColor
"private - answer the fillColor from the presentationStyle (if any)"
	| colorString |
	presentationStyle isNil
		ifTrue: [^ nil].
	""
	colorString := presentationStyle fillColor.
	colorString isNil
		ifTrue: [^ nil].
	""
	^ Color fromString: colorString! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeSpan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

OpenOfficeStyledContentsHolder subclass: #OpenOfficeTableCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeTableCell methodsFor: 'accessing' stamp: 'dgd 2/5/2004 19:48'!
backgroundColor
	"private - answer the backgroundColor from the style (if any)"
	| colorString |
	style isNil
		ifTrue: [^ Color transparent].
	""
	colorString := style backgroundColor.
	colorString isNil
		ifTrue: [^ Color transparent].
	""
	^ Color fromString: colorString! !

!OpenOfficeTableCell methodsFor: 'converting' stamp: 'dgd 2/8/2004 14:27'!
asMorph
	| childrenTextStream textMorph morph cont |
	childrenTextStream := TextStream
				on: (Text new: 400).
	super asTextIn: childrenTextStream.
	""
	textMorph := TextMorph new.
	cont := childrenTextStream contents.
	(cont isEmpty not and:[cont last = Character cr])
		ifTrue: [cont := cont allButLast].
	textMorph contents: cont.
	""
	morph := AlignmentMorph newColumn.
	morph color: self backgroundColor;
		 borderWidth: 1;
		 layoutInset: 2;
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 extent: 5 @ 5.
	""
	morph addMorphBack: textMorph.
	""
	^ morph! !

OpenOfficeStyledContentsHolder subclass: #OpenOfficeSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeContentsHolder methodsFor: 'accessing' stamp: 'dgd 1/25/2004 11:29'!
styleNamed: aString 
	"answer the style named aString or nil if none"
	^ styles
		detect: [:each | each name = aString]
		ifNone: [ super styleNamed: aString]! !

!OpenOfficeContentsHolder methodsFor: 'initialization' stamp: 'dgd 1/25/2004 11:24'!
initialize
	"initialize the receiver"
	super initialize.
	""
	contents := OrderedCollection new.

	styles := OrderedCollection new! !

OpenOfficeContentsHolder subclass: #OpenOfficeListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenOffice-Importer'!

!OpenOfficeListItem methodsFor: 'converting' stamp: 'dgd 1/24/2004 20:54'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
| bullet |
bullet := self parent bulletForItem: self.
	aTextStream nextPutAll: bullet.
	super asTextIn: aTextStream! !

!OpenOfficeElement methodsFor: 'accessing' stamp: 'dgd 1/25/2004 11:26'!
styleNamed: aString 
	"answer the style named aString or nil if none"
	^ self hasParent ifFalse:[nil] ifTrue:[self parent styleNamed: aString ]! !

!String methodsFor: '*OpenOffice-Importer-converting' stamp: 'dgd 1/22/2004 19:14'!
asTextIn: aTextStream 
	"appends a text representation of the receiver on aTextStream"
	aTextStream nextPutAll: self! !
OpenOfficeParser initialize!
